# encoding: utf-8
module Qbrick
  class AssetUploader < CarrierWave::Uploader::Base
    # Include RMagick or ImageScience support:
    include CarrierWave::MiniMagick
    # include CarrierWave::ImageScience

    # Choose what kind of storage to use for this uploader:
    storage :file
    # storage :s3

    # Override the directory where uploaded files will be stored.
    # This is a sensible default for uploaders that are meant to be mounted:
    def store_dir
      "uploads/#{mounted_as}/#{model.id}"
    end

    # Provide a default URL as a default if there hasn't been a file uploaded:
    # def default_url
    #   "/images/fallback/" + [version_name, "default.png"].compact.join('_')
    # end

    # Process files as they are uploaded:
    # process :scale => [200, 300]
    #
    # def scale(width, height)
    #   # do something
    # end

    # Create different versions of your uploaded files:
    version :thumb do
      process :resize_images
      def resize_images
        resize_to_fill(100, 100) if @file.present? && @file.content_type.present? &&
                                    @file.content_type.include?('image')
      end
    end

    # Add a white list of extensions which are allowed to be uploaded.
    # For images you might use something like this:
    def extension_white_list
      %w(jpg jpeg png pdf)
    end

    # Override the filename of the uploaded files:
    # def filename
    #   "something.jpg" if original_filename
    # end
    permissions 0600
  end
end
